// Header File
// Created 7/16/2004; 5:35:51 PM

/* waitOnMenu Occurances (board scroll)
	Pause() (false)
	Stats		(false)
	Debt Menu	(true)
	Trade Partner (false)
	Middle Trade Menu	(false)
	Trade Menu Some Options (false)
	Trade Menu All Options (false)
	Property Menu (true)
	Main Menu (true)
	RR for Sale (true)
	Tax Day Menu (true)
	Ut for Sale (true)
	Prop for Sale (true)

	In Jail (false)
*/


const unsigned char boardDispX[] = {13,13,12,10, 8, 6, 4, 3, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
																		0, 0, 1, 3, 4, 6, 8,10,12,13,13,13,13,13,13,13,13,13,13,13};
const unsigned char boardDispY[] = {25,25,25,25,25,25,25,25,25,25,25,25,25,21,17,13, 9, 5, 1, 0,
																		0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 5, 9,13,17,21,25,25};

const unsigned char piecePosX[] = {181,158,143,127,112, 96, 80, 64, 49, 33,  2,
                                     2,  2,  2,  2,  2,  2,  2,  2,  2,  2,
                                    33, 49, 64, 80, 96,111,127,143,158,181,
                                   190,190,190,190,190,190,190,190,190};
const unsigned char piecePosY[] = {190,190,190,190,190,190,190,190,190,190,190,
                                   158,143,127,111, 96, 80, 64, 49, 33,  2,
                                     2,  2,  2,  2,  2,  2,  2,  2,  2,  2,
                                    33, 49, 64, 80, 96,112,127,143,158};

// Bottom row: subtract 3 from piecePosX (x,171)
// Left row: subtract 3 from piecePosY (25,x)
// Top row: sub 3 x,   (x,25)
// Right row: sub 3 y, (171,x)
const unsigned char houses_height_B[] = {3,7,11,15,15};

void drawHouses()
{
	// Cycle through each square and check to see if they are a property with houses
	// If so, then draw the houses using an offset based on the board's position (so sprites move as board moves)
	int prop = 0; // Current square
	for(; prop < 40; prop++)
		if((convert[prop] > 0 || prop == 1) && game.numHouses[convert[prop]]) {
			// Bottom
			if(prop < 10)
				ClipSprite16_XOR_R(piecePosX[prop] - 3 - (game.boardX << 3), 171 - (game.boardY << 2), 4,
				(unsigned short *)housesA[game.numHouses[convert[prop]]], GetPlane(DARK_PLANE));
			// Left
			else if(prop < 20)
				ClipSprite16_XOR_R(25 - (game.boardX << 3), piecePosY[prop] - 3 - (game.boardY << 2),
				houses_height_B[game.numHouses[convert[prop]]-1],(unsigned short *)housesB[game.numHouses[convert[prop]]],
				GetPlane(DARK_PLANE));
			// Top
			else if(prop < 30)
				ClipSprite16_XOR_R(piecePosX[prop] - 3 - (game.boardX << 3), 25 - (game.boardY << 2), 4,
				(unsigned short *)housesC[game.numHouses[convert[prop]]], GetPlane(DARK_PLANE));
			// Right
			else
				// Mooch off of the B section for sprites, but display them starting at the
				// bottom of the prop square then move up as the number of houses increases
				ClipSprite16_XOR_R(171 - (game.boardX << 3), DEREFSMALL(piecePosY,prop) + 12 - (game.boardY << 2) -
				houses_height_B[game.numHouses[convert[prop]]-1],houses_height_B[game.numHouses[convert[prop]]-1],
				(unsigned short *)housesB[game.numHouses[convert[prop]]], GetPlane(DARK_PLANE));
		}


// Routine for the older board
/*  int prop = 0;
  for(; prop < 5; prop++) // Bottom
    if(game.numHouses[prop])
      Sprite8(houses_bottom[prop],91,1,housesA + game.numHouses[prop],GetPlane(DARK_PLANE),SPRT_OR);
  for(; prop < 11; prop++) // Left
    if(game.numHouses[prop])
      Sprite8(8,houses_left[prop - 5],8,housesB[game.numHouses[prop]],GetPlane(DARK_PLANE),SPRT_OR);
  for(; prop < 17; prop++) // Top
    if(game.numHouses[prop])
      Sprite8(houses_top[prop - 11],8,1,housesC + game.numHouses[prop],GetPlane(DARK_PLANE),SPRT_OR);
  for(; prop < 22; prop++) // Right
    if(game.numHouses[prop])
      Sprite8(91,houses_right[prop - 17],8,housesD[game.numHouses[prop]],GetPlane(DARK_PLANE),SPRT_OR);
*/
}

/*void dispPiece(int pos)
{
  DrawColorRect(dispPieceX[pos],dispPieceY[pos],dispPieceX[pos]+7,dispPieceY[pos]+7,INVERSE,RECT_FILLED);
}*/

/*int RollDice(int x)
{
	int rolled = random(6) + 1;
  Sprite16XOR(x, 60, 16, dice[rolled-1], GrayGetPlane(DARK_PLANE));
  return rolled;
}*/

void rollDice(void)
{
	// For each rolled die, pick a random number 0-5, display that sprite, then add one so it is 1-6
	game.rolled_1 = random(6);
	game.rolled_2 = random(6);
  Sprite16XOR(107, 35, 16, dice[game.rolled_1++], GrayGetPlane(DARK_PLANE));
  Sprite16XOR(133, 35, 16, dice[game.rolled_2++], GrayGetPlane(DARK_PLANE));
}

void drawBigBoard(/*int width*/)
{
	int i = 0;
	unsigned char* plane = GetPlane(DARK_PLANE);
	unsigned char* src = bigBoard + 25 * (game.boardY << 2) + game.boardX;

	// Clear the left side where the board resides
	DrawColorRect(0,0,95,99,COLOR_WHITE,RECT_FILLED);

	// Display the board. Thanks to TICT for their tutorials
	// See http://tict.ticalc.org for a non-heavily modified version of s1p1
	for(i = 0; i < 100; i++, src += 25, plane += 30)
		memcpy(plane, src, 12/*width*/);

	drawHouses();
}

void showPiece(int x, int y)
{
	Sprite8(x - (game.boardX << 3),y - (game.boardY << 2),8,piece1,GetPlane(LIGHT_PLANE),SPRT_OR);
	Sprite8(x - (game.boardX << 3),y - (game.boardY << 2),8,piece2,GetPlane(DARK_PLANE),SPRT_OR);
}

void centerBoard(int pos)
{
	game.boardX = boardDispX[pos];
	game.boardY = boardDispY[pos];
	drawBigBoard(/*STANDARD*/);
	showPiece(piecePosX[pos],piecePosY[pos]);
}

void controlBoard()
{
	// Save the screen and set it up for fullscreen, moving it if it is too far to the right
	quickSaveScr();
	//memset(GetPlane(LIGHT_PLANE), 0, LCD_SIZE);
	//memset(GetPlane(DARK_PLANE), 0, LCD_SIZE);
	//if(game.boardX > 13) game.boardX = 13;

	while(_keytest(RR_SHIFT)) {
		if(_keytest(RR_UP) && game.boardY) game.boardY--;
		if(_keytest(RR_DOWN) && game.boardY < 25) game.boardY++;
		if(_keytest(RR_RIGHT) && game.boardX < 13) game.boardX++;
		if(_keytest(RR_LEFT) && game.boardX) game.boardX--;
		drawBigBoard(/*WIDESCREEN*/);
		heartBeat();
	}
	quickRestoreScr();
	//centerBoard(game.position[game.turn]);
}